From a103f43bfa1f4aa8878106970e3ff4ab4a306404 Mon Sep 17 00:00:00 2001
From: Shashank <Shashank.ittiam@gmail.com>
Date: Tue, 17 May 2011 20:24:14 +0530
Subject: [PATCH] This patch will remove video pause when subtitle track synchronization is done in negative direction. Also it makes effect take immediate.

---
 modules/demux/subtitle.c |    9 ++++++---
 src/input/input.c        |    9 ++++++++-
 2 files changed, 14 insertions(+), 4 deletions(-)

diff --git a/modules/demux/subtitle.c b/modules/demux/subtitle.c
index 7fcd8d6..5b3ce61 100644
--- a/modules/demux/subtitle.c
+++ b/modules/demux/subtitle.c
@@ -658,11 +658,14 @@ static int Demux( demux_t *p_demux )
 {
     demux_sys_t *p_sys = p_demux->p_sys;
     int64_t i_maxdate;
+	int64_t i_delay;
 
     if( p_sys->i_subtitle >= p_sys->i_subtitles )
         return 0;
 
-    i_maxdate = p_sys->i_next_demux_date - var_GetTime( p_demux->p_parent, "spu-delay" );;
+	i_delay = var_GetTime( p_demux->p_parent, "spu-delay" );
+    i_maxdate = p_sys->i_next_demux_date - i_delay;
+
     if( i_maxdate <= 0 && p_sys->i_subtitle < p_sys->i_subtitles )
     {
         /* Should not happen */
@@ -670,7 +673,7 @@ static int Demux( demux_t *p_demux )
     }
 
     while( p_sys->i_subtitle < p_sys->i_subtitles &&
-           p_sys->subtitle[p_sys->i_subtitle].i_start < i_maxdate )
+           p_sys->subtitle[p_sys->i_subtitle].i_start + i_delay < p_sys->i_next_demux_date )
     {
         const subtitle_t *p_subtitle = &p_sys->subtitle[p_sys->i_subtitle];
 
@@ -690,7 +693,7 @@ static int Demux( demux_t *p_demux )
         }
 
         p_block->i_dts =
-        p_block->i_pts = VLC_TS_0 + p_subtitle->i_start;
+        p_block->i_pts = VLC_TS_0 + p_subtitle->i_start + i_delay;
         if( p_subtitle->i_stop >= 0 && p_subtitle->i_stop >= p_subtitle->i_start )
             p_block->i_length = p_subtitle->i_stop - p_subtitle->i_start;
 
diff --git a/src/input/input.c b/src/input/input.c
index 63a1480..8f7cd2a 100644
--- a/src/input/input.c
+++ b/src/input/input.c
@@ -1895,7 +1895,14 @@ static bool Control( input_thread_t *p_input,
 
         case INPUT_CONTROL_SET_SPU_DELAY:
             input_SendEventSubtitleDelay( p_input, val.i_time );
-            UpdatePtsDelay( p_input );
+            /*
+             * Not required for Subtitile. This removes video pause when track synchronization
+             * is used in negative direction. With this commented effect is immediate.
+             *
+             * UpdatePtsDelay( p_input );
+             *
+             */
+
             break;
 
         case INPUT_CONTROL_SET_TITLE:
-- 
1.7.4.msysgit.0

